@echo off
rem echo on

setlocal

set DMI_LOCATION=C:\CallPilot
set DMI_API_FILE=dmi_api.dll
set SU_NAME=CP20127SU03S
set SU_UNINSTALL_LOCATION=%DMI_LOCATION%\patch\nb%SU_NAME%
set SU_BACKUP_LOCATION=D:\pepbkp\nm
set DMI_API_BACKUP_FILE=%SU_BACKUP_LOCATION%\%DMI_API_FILE%.original
set SU_INSTALL_SUC=D:\Temp\%SU_NAME%_runme.temp

if not exist %SU_NAME% goto internal_error

pushd %SU_NAME%

rem ----------------------------------------------------------------------------------
rem 
rem Phase of checking some requirements
rem
rem ----------------------------------------------------------------------------------

if not exist %DMI_LOCATION% goto this_is_not_callpilot

if exist %SU_BACKUP_LOCATION% goto cont_checking

mkdir %SU_BACKUP_LOCATION%

if not exist %SU_BACKUP_LOCATION% goto we_cannot_create_dir

:cont_checking

rem
rem Check that the following tools: dmi_view, ecs, DMIEditor are not in memory
rem

FOR /F "tokens=1" %%i IN ('pulist^|find /I "dmi_view.exe"') DO set FIND_TOOL1=%%i

if (%FIND_TOOL1%) NEQ () goto we_can_not_copy

FOR /F "tokens=1" %%i IN ('pulist^|find /I "ecs.exe"') DO set FIND_TOOL2=%%i

if (%FIND_TOOL2%) NEQ () goto we_can_not_copy

FOR /F "tokens=1" %%i IN ('pulist^|find /I "DMIEditor.exe"') DO set FIND_TOOL3=%%i

if (%FIND_TOOL3%) NEQ () goto we_can_not_copy


rem ----------------------------------------------------------------------------------
rem 
rem Phase of backuping
rem
rem ----------------------------------------------------------------------------------

echo Please wait as Setup updates the dmi_api.dll library....

rem
rem check that the original version of dmi_api.dll exists
rem If not then copy the file for backup purpose
rem

if exist %DMI_API_BACKUP_FILE% goto do_not_copy

rem
rem save a copy the library and update the file
rem

copy /V /Z %DMI_LOCATION%\%DMI_API_FILE% %DMI_API_BACKUP_FILE% >NUL
if errorlevel 1 goto error_backup_copy

copy /V /Z %DMI_API_FILE% %DMI_LOCATION%\%DMI_API_FILE% >NUL
if errorlevel 1 goto error_library_copy

rem
rem The library has been copied
rem

rem short pause to give time for the library to be copied

waitnt 1

rem ----------------------------------------------------------------------------------
rem 
rem Phase of SU installation
rem
rem ----------------------------------------------------------------------------------

rem
rem start TU/SU installing
rem

:do_not_copy

popd

echo Please wait as Setup stops the MTX process....

mtxstop.exe

echo Starting PEP installer....

ins.exe

goto END


rem ----------------------------------------------------------------------------------
rem 
rem Errors and warnings processing ....
rem
rem ----------------------------------------------------------------------------------

:error_library_copy
rem
rem Could not update the library
rem

echo Error. Could not update %DMI_API_FILE%.
echo      Reboot CallPilot and try to install %SU_NAME% again.

pause

popd
goto :END

:error_backup_copy
rem
rem Could not backup the library
rem

echo Error: Could not copy the file %DMI_LOCATION%\%DMI_API_FILE% to %DMI_API_BACKUP_FILE%.
echo      Reboot CallPilot and try to install %SU_NAME% again.

pause

popd
goto :END

:this_is_not_callpilot
rem
rem This server is not a CallPilot server
rem

echo Error: This server is not a CallPilot server.

pause

popd
goto :END

:we_can_not_copy
rem
rem One of tools in memory. Ask to stop the tools and try to install SU again
rem

echo Error: This setup requires that you close all applications and support tools. 
echo Please close DMI Tools and try to install %SU_NAME% again

pause

popd
goto :END

:we_cannot_create_dir
rem
rem Could not create dir
rem

echo Error: setup could not create the directory %SU_BACKUP_LOCATION%

pause

popd
goto :END

:internal_error
rem
rem Could not create dir
rem

echo Internal Error: Could not find the %SU_NAME% directory.

pause

goto :END

:END

endlocal
